/**
 * Created by aaronlin on 2017/8/14.
 */
import {
    StyleSheet,
    Platform,
} from 'react-native';

import './toast';

import PickerView from './picker/PickerView';
import PickerTimeDialog from './picker/PickerTimeDialog';
import HtmlView from './html/HtmlView';
import NoticeViewV2 from './NoticeViewV2';
import WMImage from './WMImage';
import WMView from './WMView';
import WMText from './WMText';
import WMTextInput from './WMTextInput';
import SendCodeButton from './SendCodeButton';
import WMButton from './WMButton';
import WMRadioGroup from './WMRadioGroup';
import RefreshListView from './refreshlistview/RefreshListView';
import Refreshing from './refreshlistview/Refreshing';
import PullToRefreshContainerV2 from './pulltorefresh/PullToRefreshContainerV2';
import BannerView from './bannerview/BannerView';
import ViewPager from './viewpager/ViewPager';
import BaseAdapterComponent from './base/BaseAdapterComponent';
import LeftSlideCellMenuView from './slidemenu/LeftSlideCellMenuView';
import SlideMenuView from './slidemenu/SlideMenuView';
import LineProgressBar from './progressbar/LineProgressBarAnim';
import WMModal from './modal/WMModal';
import Badge from './badge/Badge';

export {
    Badge,
    SlideMenuView,
    LeftSlideCellMenuView,
    BaseAdapterComponent,
    ViewPager,
    BannerView,
    PickerView,
    PickerTimeDialog,
    HtmlView,
    NoticeViewV2,
    WMImage,
    WMView,
    WMText,
    WMTextInput,
    SendCodeButton,
    WMButton,
    WMRadioGroup,
    RefreshListView,
    Refreshing,
    PullToRefreshContainerV2,
    LineProgressBar,
    WMModal,
}

/**
 * hook StyleSheet
 */
+function hookStyleSheet() {
    const originCreate = StyleSheet.create;
    StyleSheet.create = function(styleObj){
        let style = {};
        for(let styleKey in styleObj){
            let { android, ios, ...otherStyle } = styleObj[styleKey];

            let platformStyle = null;

            if(Platform.OS === 'android' && android){
                platformStyle = android;
            }

            if(Platform.OS === 'ios' && ios) {
                platformStyle = ios;
            }

            style[styleKey] = {...otherStyle, ...platformStyle};
        }
        return originCreate(style);
    }
}();