/**
 * Created by aaronlin on 2017/8/10.
 */
import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import ReactNative, {
    View,
    Text,
    Picker,
    ViewPropTypes,
} from 'react-native';

/**
 *
 */
const PICK_ITEM = "pick_item";

export default class PickerView extends PureComponent {

    static propTypes = {
        ...ViewPropTypes,
        data: PropTypes.array,     //数据源  字符串数组
        selectedValue: PropTypes.number,    //默认选中的位置, 只能是数字   默认：0
        onValueChange: PropTypes.func, //某一项被选中时执行此回调
        tag: PropTypes.object,
    }

    static defaultProps = {
        selectedValue: 0,
        data: [],
    }

    constructor(props) {
        super(props);

        this.state = {
            data: props.data,
            selectedValue: props.selectedValue,
        }
    }

    /**
     * 
     */
    _onValueChange = (value, position) => {
        this.setState({
            selectedValue: value,
        })

        let label = this.state.data ? this.state.data[position] : "";
        this.props.onValueChange && this.props.onValueChange(label, position, this.props.tag);
    }

    render() {

        let data = this.state.data;
        let pickerItemViewArray = [];
        for (let i = 0; i < data.length; i++) {
            pickerItemViewArray.add(<Picker.Item key={PICK_ITEM + i} label={data[i].toString()} value={i} />);
        }

        return (
            <Picker
                ref='nativePicker'
                {...this.props}
                selectedValue={this.state.selectedValue}
                onValueChange={this._onValueChange}
            >
                {pickerItemViewArray}
            </Picker>
        );
    }

    setData = (dataList) => {
        console.log("setData=======>", dataList);
        this.setState({
            data: dataList,
        })
    }

    setSelectIndex = (index) => {
        this.setState({
            selectedValue: index,
        })
    }
}