/**
 * Created with IntelliJ IDEA.
 * User: aaronlin
 * Date: 2018/5/14
 * Time: 17:46
 */

import React, { PureComponent } from 'react';
import ReactNative, {
    View,
    Text,
    Platform,
    requireNativeComponent,
    UIManager,
} from 'react-native';

/**
 *
 */
const NativeRecyclerItemView = requireNativeComponent('AndroidRecyclerItemView', RecyclerItemView);

/**
 *
 */
export default class RecyclerItemView extends PureComponent{

    constructor(props){
        super(props);

        this.state = {
            position: this.props.position,
        }
    }

    /**
     *
     * @private
     */
    _onUpdateItem = (e)=>{
        const { nativeEvent } = e;
        const { position } = nativeEvent;

        this.setState({ position });
    }

    /**
     *
     * @private
     */
    _getItemContainerViewHandle = ()=>{
        if(this.refs.itemContainerView){
            return ReactNative.findNodeHandle(this.refs.itemContainerView);
        }
    }

    render(){
        const { dataList, renderRow, renderSeparator } = this.props;

        const { position } = this.state;

        const data = position >= dataList.length ? dataList[0] : dataList[position];

        return (
            <NativeRecyclerItemView
                ref="nativeRecyclerItemView"
                onUpdateItem={this._onUpdateItem}
            >

                <View ref={'itemContainerView'} pointerEvents={'box-none'} style={styles.itemContainer}>

                    { renderRow && renderRow(data.data, data.sectionID, data.rowID) }

                    { renderSeparator && renderSeparator() }

                </View>

            </NativeRecyclerItemView>
        );
    }

}

const styles = {
    itemContainer:{
        backgroundColor:'transparent',
        width:'100%',
    }
}